# -*- coding: utf-8 -*-

###########################################################################
## 程序设计 danscort yu (c)2021
## www.phoenixp2p.com
##
## sync and backup program for XFile server
## 
###########################################################################
###########################################################################
## 本代码是基于xftp.py修改而来,因此看着可能有点怪有点傻, 这个代码为XFile服务器提供类似同步和备份工具
## 同时实现了备份和同步操作的基本功能 请根据需要进行修改 , 例如 windows 系统允许文件名和目录中包含空格,大小写不敏感 而Linux不支持包含空格,大小写敏感 
## 由于XFile服务器支持多种操作系统,支持的文件系统更是超级多,我们无法象商用nas一样限制在某个文件系统而利用该系统特性,我们的工具也只能说实现了基础的备份和同步
## 一般,如果你的XFile是windows平台搭建,而客户端是Linux,那么你最好人肉保证同一目录下不存在类似 T123.txt t123.txt 这种只有大小写不同的文件,否则将出问题
## 同样 如果你的XFile是linux平台搭建,那么你要备份或者同步的目录以及下面的文件名,不能包含空格等,否则会失败
## 
## 使用python实现这个功能,是为了方便跨平台,同时提供各位有兴趣的朋友,根据自己的需要进行修改
## 但是请注意 本代码仅支持XFile的备份模式,其他标准Ftp服务器软件是无法支持的,因为使用了大量的XFile扩展指令
## 如果要实现基于Ipv6的远程备份或者同步 , 可以配合我们提供的xfiledns程序来自动获取服务器的动态ipv6地址
## 
## 之所以将代码写成一个个函数方式,是因为我们希望提供一个基础的python版本XFile客户端功能实现,方便各位有兴趣的朋友进行扩展编程
## 特别提醒,python 3.7/3.8/3.9 的ftplib 库的TLS/SSL文件加密传输存在bug,这是ftplib库本身代码的bug,不要启用tls上传文件,否则会卡死超时,具体原因stackoverflow上已经有明确的说明,但是始终没有被修复,除非你人肉hack进去修改ftplib库里的storBinary等函数的实现,否则无解
## 您可以任意修改本代码 但是请保留本说明部分
## 作者: danscort@phoenixp2p.com
## 最后编辑:2021.06
##
###########################################################################
import xfile
     

##下面是主程序
                
if __name__ == '__main__':
    # When this module is run (not imported) then create the app
    # 
    frm = xfile.MainClass()
    if(xfile._debugmode):
        xfile._ftp.set_debuglevel(2)
        xfile._ftps.set_debuglevel(2)
    print("Backup and sync program for XFile by danscort yu [2021.07.01]")
    print("License: https://www.phoenixp2p.com/cn/xlic.htm")
    #由于该死的utf8-bom 可能存在 因此这里不得不采用连续尝试 先尝试带bom 如果失败 再尝试不带bom方式
    if(frm.FuncLoadConfigFile(True)==False):
        if(xfile._debugmode):
            print("Error load config file with utf8-bom")
        if(frm.FuncLoadConfigFile(False)==False):
            print("Fatal error: failed to load config file in bom and no bom mode.")    
            frm.FuncExit()

    #为了防止出大意外 这里禁止将内容直接备份到根目录下，因为万一是同步模式并且设置错误，那么服务器上备份目录下的内容就会被误删除，后果太严重了       
    if(len(xfile.set_serverbkdir)<=1):
        print("Error: bad set of remote backup dir")
        frm.FuncExit( )       
    #如果设置了dnsfile  那么就尝试装入吧
    if(xfile.set_addrfromdns):
        frm.FuncLoadDnsFile( )
    else:
        print("Dns file is null, skipped")    
    if(frm.ConnectToServer()==False):
        if(xfile._debugmode):
            print("Error to connect to server")
        frm.FuncExit()

    str1=frm.FuncSendRawCmd2("SLST","0")
    if(xfile._debugmode):
        #只在调试模式下才需要结果
        print(str1)
    if(len(str1)<4):
        frm.FuncExit()
    if(frm.FuncGetNumFromResponse(str1.strip())>=400):
        if(xfile._debugmode):
            print("Bad response from server of SLST")
        frm.FuncExit()
    #如果用户设置了账户反馈码 那么还需要对账户反馈码进行校验 能过这个校验的蜜罐服务器目前是不存在的 除非二次sha256加盐校验被破解了
    if(frm.FuncCheckRespcode()==False):
        print("Fatal error, check account response code failed")
        frm.FuncExit( )
    
    
    #frm.FuncSendRawCmd2("SLST","0")
    ##由于python ftplib ssl 实现存在bug 这个bug 目前没有被修复 因此必须强行关闭数据端ssl
    if(xfile.set_tls):
        #注意 这里必须是False python ftplib 存在bug
        frm.FuncSetProt_P(False)
        
    ##################################################################################
    ##
    ##
    ## 如果你要实现自己的的扩展功能，例如批量改名等，那么请将你的代码放到下面，而把原来的代码注销或者删除就可以
    ## 上面的部分是自动实现XFile服务器登录的代码，不建议改动
    ##
    ##
    ###################################################################################

    if(frm.FuncTestDirRW(xfile.set_localbkdir,True)==False):
        print("Fatal error: local path not exist or need sudo :"+xfile.set_localbkdir)
        frm.FuncExit( )
    #这里尝试创建所有目录
    if(frm.FuncMakefullDir(True)==False):
        print("Failed to makefull dir")  
    #这里正式开始尝试第一个备份或者同步操作
    print("========Sync 1 start=========")
    frm.FuncSync(xfile.set_localbkdir,xfile.set_serverbkdir)
    print("=============Sync 1 end====================") 

    if(len(xfile.set_serverbkdir2)<=1 or len(xfile.set_localbkdir2)<=1 or frm.FuncTestDirRW(xfile.set_localbkdir2,True)==False):
        print("Sync 2 not active")
    else:
        
        #执行第二个备份或者同步操作
        #这里尝试创建第二个目录
        if(frm.FuncMakefullDir(False)==False):
            #
            print("Failed to makefull dir 2")
            frm.FuncDisconnect( )
            frm.FuncExit( )  
        #这里正式开始尝试同步操作
        print("========Sync 2 start=========")
        frm.FuncSync(xfile.set_localbkdir2,xfile.set_serverbkdir2)
        print("=============Sync 2 end====================") 

    
   

    print("========All done========")
    frm.FuncDisconnect( )
    frm.FuncExit( )
                                
